template<typename A, typename B, typename C=CPy>
class IfPa;

template<typename A,typename B,typename C>
class ElPa
{
public:
    ElPa() { }
};

/* Only the if_p<> that has CPy in the else branch, can redefine an else branch */
template<> template<typename A,typename B>
class ElPa<A,B,CPy>
{
    const IfPa<A,B,CPy>& if_p;
public:
    ElPa(const IfPa<A,B,CPy>& i) : if_p(i) { }
    
    template<typename D>
    IfPa<A,B, Expecter<D> >
    operator[] (const parser<D>& d) const
    {
        /* Since we use Expecter, we don't need to worry about
         * if someone tries .else_p [eps_p].else_p[...]
         *
         * But we really use Expecter here because
         * it's also used in the "then" part.
         */
        return IfPa<A,B, Expecter<D> > (if_p.opt_if,if_p.opt_then, d.expected());
    }
};

template<typename A, typename B, typename C>
class IfPa: public parser<IfPa<A,B,C> >
{
    typedef IfPa<A,B,C> this_t;
    typedef parser<this_t> base_t;
    const A opt_if;
    const B opt_then;
    const C opt_else;
    
    friend class ElPa<A,B,C>;
public:
    const ElPa<A,B,C> else_p;
public:    
    IfPa(const parser<A>& a, const parser<B>& b)
        : base_t(), opt_if(a.derived()), opt_then(b.derived()), opt_else(),
          else_p(*this) { }

    IfPa(const parser<A>& a, const parser<B>& b, const parser<C>& c)
        : base_t(), opt_if(a.derived()), opt_then(b.derived()), opt_else(c.derived()),
          else_p() { }

    template<typename ScannerT>
    bool parse(ScannerT& scan) const
    {
        typename ScannerT::iterator begin = scan.pos();
        if(opt_if.parse(scan))
        {
            if(!opt_then.parse(scan)) { scan.revert(begin); return false; }
        }
        return opt_else.parse(scan);
    }
    const std::string what() const { return opt_if.what(); }
};
template<typename A>
class IfPg
{
    const A& ref;
public:
    IfPg(const parser<A>& a) : ref(a.derived()) { }

    template<typename B>
    IfPa<A,Expecter<B> >
    operator[] (const parser<B>& b) const
    {
        return IfPa<A,Expecter<B> > (ref, b.expected());
    }
};
template<typename A>
IfPg<A> if_p(const parser<A>& a) { return IfPg<A>(a); }
